diff --git a/src/backend/replication/logical/reorderbuffer.c b/src/backend/replication/logical/reorderbuffer.c
index c2d9be81fa..d03d6c5600 100644
--- a/src/backend/replication/logical/reorderbuffer.c
+++ b/src/backend/replication/logical/reorderbuffer.c
@@ -1110,6 +1110,12 @@ ReorderBufferQueueSequence(ReorderBuffer *rb, TransactionId xid,
 								 MAIN_FORKNUM));
 
 			relation = RelationIdGetRelation(reloid);
+			if (!RelationIsValid(relation))
+				elog(ERROR, "could not open relation with OID %u (for filenode \"%s\")",
+					 reloid,
+					 relpathperm(rnode,
+								MAIN_FORKNUM));
+
 			tuple = &tuplebuf->tuple;
 			seq = (Form_pg_sequence_data) GETSTRUCT(tuple);